#ifndef _DIALOGS_TABSCHED_CPP
#define _DIALOGS_TABSCHED_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>
#include <CommCtrl.h>

#include "../Resources/Resource.H"

#include "../../SharedSource/NSWFL.H"
#include "../Source/Entry.H"
#include "../Source/Routines.H"

#include "../Dialogs/TabSched.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int GetTheNumberOfCheckedDays(HWND hWnd)
{
	int iChecked = 0;

	if(IsDlgButtonChecked(hWnd, ID_DAY_SUN) == BST_CHECKED) iChecked++;
	if(IsDlgButtonChecked(hWnd, ID_DAY_MON) == BST_CHECKED) iChecked++;
	if(IsDlgButtonChecked(hWnd, ID_DAY_TUE) == BST_CHECKED) iChecked++;
	if(IsDlgButtonChecked(hWnd, ID_DAY_WED) == BST_CHECKED) iChecked++;
	if(IsDlgButtonChecked(hWnd, ID_DAY_THU) == BST_CHECKED) iChecked++;
	if(IsDlgButtonChecked(hWnd, ID_DAY_FRI) == BST_CHECKED) iChecked++;
	if(IsDlgButtonChecked(hWnd, ID_DAY_SAT) == BST_CHECKED) iChecked++;

	return iChecked;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void LoadWeekDaysFromDialog(HWND hWnd)
{
	gbWeekDays[0] = (IsDlgButtonChecked(hWnd, ID_DAY_SUN) == BST_CHECKED);
	gbWeekDays[1] = (IsDlgButtonChecked(hWnd, ID_DAY_MON) == BST_CHECKED);
	gbWeekDays[2] = (IsDlgButtonChecked(hWnd, ID_DAY_TUE) == BST_CHECKED);
	gbWeekDays[3] = (IsDlgButtonChecked(hWnd, ID_DAY_WED) == BST_CHECKED);
	gbWeekDays[4] = (IsDlgButtonChecked(hWnd, ID_DAY_THU) == BST_CHECKED);
	gbWeekDays[5] = (IsDlgButtonChecked(hWnd, ID_DAY_FRI) == BST_CHECKED);
	gbWeekDays[6] = (IsDlgButtonChecked(hWnd, ID_DAY_SAT) == BST_CHECKED);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void LoadWeekDaysIntoDialog(HWND hWnd)
{
	if(gbWeekDays[0]) CheckDlgButton(hWnd, ID_DAY_SUN, BST_CHECKED);
	if(gbWeekDays[1]) CheckDlgButton(hWnd, ID_DAY_MON, BST_CHECKED);
	if(gbWeekDays[2]) CheckDlgButton(hWnd, ID_DAY_TUE, BST_CHECKED);
	if(gbWeekDays[3]) CheckDlgButton(hWnd, ID_DAY_WED, BST_CHECKED);
	if(gbWeekDays[4]) CheckDlgButton(hWnd, ID_DAY_THU, BST_CHECKED);
	if(gbWeekDays[5]) CheckDlgButton(hWnd, ID_DAY_FRI, BST_CHECKED);
	if(gbWeekDays[6]) CheckDlgButton(hWnd, ID_DAY_SAT, BST_CHECKED);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CheckAll(HWND hWnd, bool bCheck)
{
	int iDay = 0;
	int iState = 0;

	if(bCheck)
	{
		iState = BST_CHECKED;
	}
	else{
		iState = BST_UNCHECKED;
	}

	CheckDlgButton(hWnd, ID_DAY_SUN, iState);
	CheckDlgButton(hWnd, ID_DAY_MON, iState);
	CheckDlgButton(hWnd, ID_DAY_TUE, iState);
	CheckDlgButton(hWnd, ID_DAY_WED, iState);
	CheckDlgButton(hWnd, ID_DAY_THU, iState);
	CheckDlgButton(hWnd, ID_DAY_FRI, iState);
	CheckDlgButton(hWnd, ID_DAY_SAT, iState);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK TabSchedDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
    static HWND TimeWindowBegin_hWnd     = NULL;
    static HWND TimeWindowEnd_hWnd       = NULL;

	static HWND Hours_hWnd = NULL;
	static HWND Minutes_hWnd = NULL;
	static HWND HoursUD_hWnd = NULL;
	static HWND MinutesUD_hWnd = NULL;

    if(xMessage == WM_INITDIALOG)
    {
        TimeWindowBegin_hWnd     = GetDlgItem(xHandle, ID_TIMEWINDBEGIN);
        TimeWindowEnd_hWnd       = GetDlgItem(xHandle, ID_TIMEWINDEND);

        Hours_hWnd       = GetDlgItem(xHandle, ID_HOURS);
        Minutes_hWnd     = GetDlgItem(xHandle, ID_MINUTES);
        HoursUD_hWnd     = GetDlgItem(xHandle, ID_HOURUD);
        MinutesUD_hWnd   = GetDlgItem(xHandle, ID_MINUD);

		SendMessage(HoursUD_hWnd,(UINT)UDM_SETBUDDY, (WPARAM)Hours_hWnd, (LPARAM)NULL);
		SendMessage(HoursUD_hWnd,(UINT)UDM_SETRANGE, (WPARAM)NULL,(LPARAM)MAKELONG(23, 0));

		SendMessage(MinutesUD_hWnd,(UINT)UDM_SETBUDDY, (WPARAM)Minutes_hWnd, (LPARAM)NULL);
		SendMessage(MinutesUD_hWnd,(UINT)UDM_SETRANGE, (WPARAM)NULL, (LPARAM)MAKELONG(59, 0));

		if(gdwConnectInterval > 0)
		{
			Set_Long(Hours_hWnd, gdwConnectInterval / 60);
			Set_Long(Minutes_hWnd, gdwConnectInterval % 60);
		}
		else{
			Set_Long(Hours_hWnd, 0);
			Set_Long(Minutes_hWnd, 0);
		}

		SYSTEMTIME MyST;

		GetLocalTime(&MyST);

		LongToTime(gdwStartTime, (int *)&MyST.wHour, (int *)&MyST.wMinute, (int *)&MyST.wSecond);
    	SendMessage(TimeWindowBegin_hWnd, MCM_SETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &MyST);

		LongToTime(gdwStopTime, (int *)&MyST.wHour, (int *)&MyST.wMinute, (int *)&MyST.wSecond);
		SendMessage(TimeWindowEnd_hWnd, MCM_SETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &MyST);

		LoadWeekDaysIntoDialog(xHandle);

        return TRUE;
    }

    if(xMessage == WM_COMMAND)
    {
		if(wParam == ID_SCHED_ALL)
		{
			CheckAll(xHandle, true);
		}

		if(wParam == ID_SCHED_NONE)
		{
			CheckAll(xHandle, false);
		}

        return FALSE;
    }

    if(xMessage == WM_NOTIFY)
    {
        LPNMHDR pNMH = (LPNMHDR)lParam;
        if(pNMH->code == PSN_KILLACTIVE)
        {
            return FALSE;
        }
        if(pNMH->code == PSN_APPLY) // Ok
        {
			if(GetTheNumberOfCheckedDays(xHandle) == 0)
			{
				MessageBox(xHandle, "You must check at least one schedule day.", gsTitleCaption, 0);
				SetWindowLong(xHandle, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE); // Prevent window from closing
				return FALSE;
			}

			SYSTEMTIME MyST;

			DWORD ldwHours       = Get_Long(Hours_hWnd);
			DWORD ldwMinutes     = Get_Long(Minutes_hWnd);
			DWORD ldwConInterval = (ldwHours * 60) + ldwMinutes;
			DWORD ldwStartTime   = 0;
			DWORD ldwStopTime    = 0;

			GetLocalTime(&MyST);

    		SendMessage(TimeWindowBegin_hWnd, MCM_GETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &MyST);
			ldwStartTime = TimeToLong(MyST.wHour, MyST.wMinute, MyST.wSecond);

    		SendMessage(TimeWindowEnd_hWnd, MCM_GETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &MyST);
			ldwStopTime = TimeToLong(MyST.wHour, MyST.wMinute, MyST.wSecond);

			if(ldwConInterval)
			{
				MessageBox(xHandle, "You must specify a connection interval.", gsTitleCaption, 0);
				SetWindowLong(xHandle, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE); // Prevent window from closing
				return FALSE;
			}

			if(gdwStartTime > gdwStopTime)
			{
				MessageBox(xHandle, "The time window that you have selected is invalid.", gsTitleCaption, 0);
				SetWindowLong(xHandle, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE); // Prevent window from closing
				return FALSE;
			}

			gdwStartTime = ldwStartTime;
			gdwStopTime = ldwStopTime;

			gdwConnectInterval = ldwConInterval;
			
			LoadWeekDaysFromDialog(xHandle);

			return TRUE;
        }
        if(pNMH->code == PSN_RESET) // Cancel
        {
            return FALSE;
        }
    }

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
